'Connect file for PICAXE-18M
'Version 0.1

'return word
symbol return_word = w0
symbol return_byte = b0
symbol return_high = b1

'command data
symbol cmd = b2
symbol param1 = b3
symbol param2 = b4
symbol param3 = b5

symbol cmd_dirs = 31		; dirs
symbol cmd_pins = 32		; pins
symbol cmd_sound = 33		; sound
symbol cmd_play = 34		; play
symbol cmd_tune = 35
symbol cmd_pulsout = 36		; pulsout
symbol cmd_infraout = 37	; infraout
symbol cmd_serout = 38		; serout
symbol cmd_pwm = 39
symbol cmd_pwmout = 40
symbol cmd_servo = 41

symbol cmd_readadc = 60		; readadc
symbol cmd_readadc10 = 61	; readadc10
symbol cmd_readtemp = 62	; readtemp
symbol cmd_readtemp12 = 63	; readtemp12
symbol cmd_pulsin = 64		; pulsin
symbol cmd_infrain = 65		; infrain2	
symbol cmd_count = 66		; count
symbol cmd_serin = 67

symbol cmd_reconnect = 255	; reconnect



init:
	'disconnect so serrxd pin is free
	disconnect
	
main:
	'always receive ? then 4 bytes
	serrxd ("?"),cmd,param1,param2,param3

	'preload return_data with default value
	'which is the input pins value
	let return_word = pins
	
	'find the cmd and do it
	select case cmd

	'dirs and pins
	case cmd_dirs
		'let dirs = param1
	case cmd_pins
		let pins = param1

	'special input commands
	case cmd_readadc
		readadc param1,return_word
	case cmd_readadc10
		readadc10 param1,return_word
	case cmd_readtemp
		readtemp param1,return_word
	case cmd_readtemp12
		readtemp12 param1,return_word
	case cmd_infrain
		infrain2
		return_word = infra
	case cmd_pulsin
		pulsin param1,param2,return_word
	case cmd_count
		count param1,param2,return_word

	'special output commands
	case cmd_sound
		sound param1,(param2,param3)
	case cmd_play
		play param1,param2	
	case cmd_pulsout
		pulsout param1,param2
	case cmd_infraout
		infraout param1,param2
	case cmd_serout
		serout param1,param2,(param3)

	'special reconnect command
	case cmd_reconnect
		'now stop here until reset
		reconnect
		stop			
	end select
	

	'echo back the cmd and any return data
	sertxd (cmd,return_byte,return_high)

	'loop back to start
	goto main
	
	
	